import 'package:osam/src/persist/persist_repository.dart';

abstract class Persist<ST, US> {
  factory Persist.instance() => PersistRepository<ST, US>();
  Future<void> initPersist(String appName);

  Future<void> save(ST state, US uiState);

  ST getState();

  US getUiState();

  Future<void> delete();

  Future<void> deleteFromDisk(String appName);

  Future<void> deleteHive();

  bool get isPersistEnabled;
}
